<?php
/**
* Sidebar Metabox.
*
* @package Advance Blog
*/
 
add_action( 'add_meta_boxes', 'advance_blog_metabox' );

if( ! function_exists( 'advance_blog_metabox' ) ):


    function  advance_blog_metabox() {
        
        add_meta_box(
            'theme-custom-metabox',
            esc_html__( 'Layout Settings', 'advance-blog' ),
            'advance_blog_post_metafield_callback',
            'post', 
            'normal', 
            'high'
        );
        add_meta_box(
            'theme-custom-metabox',
            esc_html__( 'Layout Settings', 'advance-blog' ),
            'advance_blog_post_metafield_callback',
            'page',
            'normal', 
            'high'
        ); 
    }

endif;

$advance_blog_post_sidebar_fields = array(
    'global-sidebar' => array(
                    'value' => 'global-sidebar',
                    'label' => esc_html__( 'Global sidebar', 'advance-blog' ),
                ),
    'sidebar-right' => array(
                    'value' => 'sidebar-right',
                    'label' => esc_html__( 'Right sidebar', 'advance-blog' ),
                ),
    'sidebar-left' => array(
                    'value'     => 'sidebar-left',
                    'label'     => esc_html__( 'Left sidebar', 'advance-blog' ),
                ),
    'no-sidebar' => array(
                    'value'     => 'no-sidebar',
                    'label'     => esc_html__( 'No sidebar', 'advance-blog' ),
                ),
);
add_action( 'admin_enqueue_scripts', 'advance_blog_backend_scripts');
if ( ! function_exists( 'advance_blog_backend_scripts' ) ){
    function advance_blog_backend_scripts( $hook ) {
        if(('post.php' === $hook) ||('page.php' === $hook) || ('page-new.php' === $hook)||('post-new.php' === $hook)){
            wp_enqueue_style( 'wp-color-picker');
            wp_enqueue_script( 'wp-color-picker');
        }
    }
}

/**
 * Callback function for post option.
*/
if( ! function_exists( 'advance_blog_post_metafield_callback' ) ):
    
    function advance_blog_post_metafield_callback() {
        global $post, $advance_blog_post_sidebar_fields;
        $post_type = get_post_type($post->ID);
        $post_type = get_post_type($post->ID);
        $ut_ed_twitter_summary = get_theme_mod('ut_ed_twitter_summary');
        $ut_ed_open_graph = get_theme_mod('ut_ed_open_graph');
        wp_nonce_field( basename( __FILE__ ), 'advance_blog_post_meta_nonce' ); ?>
        
        <div class="metabox-main-block">

            <div class="metabox-navbar">
                <ul>

                    <li>
                        <a id="metabox-navbar-general" class="metabox-navbar-active" href="javascript:void(0)">

                            <?php esc_html_e('Appearance Settings', 'advance-blog'); ?>

                        </a>
                    </li>

                </ul>
            </div>

            <div class="theme-tab-content">

                <div id="metabox-navbar-general-content" class="metabox-content-wrap metabox-content-wrap-active">

                    <div class="metabox-opt-panel">

                        <h3 class="meta-opt-title"><?php esc_html_e('Sidebar Layout','advance-blog'); ?></h3>

                        <div class="metabox-opt-wrap metabox-opt-wrap-alt">

                            <?php
                            $advance_blog_post_sidebar = esc_html( get_post_meta( $post->ID, 'advance_blog_post_sidebar_option', true ) ); 
                            if( $advance_blog_post_sidebar == '' ){ $advance_blog_post_sidebar = 'global-sidebar'; }

                            foreach ( $advance_blog_post_sidebar_fields as $advance_blog_post_sidebar_field) { ?>

                                <label class="description">

                                    <input type="radio" name="advance_blog_post_sidebar_option" value="<?php echo esc_attr( $advance_blog_post_sidebar_field['value'] ); ?>" <?php if( $advance_blog_post_sidebar_field['value'] == $advance_blog_post_sidebar ){ echo "checked='checked'";} if( empty( $advance_blog_post_sidebar ) && $advance_blog_post_sidebar_field['value']=='sidebar-right' ){ echo "checked='checked'"; } ?>/>&nbsp;<?php echo esc_html( $advance_blog_post_sidebar_field['label'] ); ?>

                                </label>

                            <?php } ?>

                        </div>

                    </div>


                    <?php $advance_blog_ed_feature_image = esc_attr(get_post_meta($post->ID, 'advance-blog-meta-checkbox', true)); ?>
                    <div class="metabox-opt-panel">
                        <div class="metabox-opt-wrap theme-checkbox-wrap">
                            <input id="advance-blog-ed-feature-image" name="advance-blog-meta-checkbox" type="checkbox" <?php if ($advance_blog_ed_feature_image) { ?> checked="checked" <?php } ?> />
                            <label for="advance-blog-ed-feature-image"><?php esc_html_e('Disable Feature Image', 'advance-blog'); ?></label>
                        </div>
                    </div>

                    <?php if( $post_type == 'post' ){ ?>

                        <script>
                            jQuery(document).ready(function($){
                                $('.color_field').each(function(){
                                    $(this).wpColorPicker();
                                });
                            });
                        </script>

                        <div class="metabox-opt-panel">
                            <div class="metabox-opt-wrap metabox-opt-wrap-alt">
                                <label><?php esc_html_e('Choose a color for your Post Backgorund.', 'advance-blog'); ?></label>
                                <input class="color_field" name="advance_blog_background_color" type="text" value="<?php echo esc_attr(get_post_meta($post->ID, 'advance_blog_background_color', true)); ?>"/>
                            </div>
                        </div>

                        <div class="metabox-opt-panel">
                            <div class="metabox-opt-wrap metabox-opt-wrap-alt">
                                <label><?php esc_html_e('Choose a color for your Post Text.', 'advance-blog'); ?></label>
                                <input class="color_field" name="advance_blog_text_color" type="text" value="<?php echo esc_attr(get_post_meta($post->ID, 'advance_blog_text_color', true)); ?>"/>
                            </div>
                        </div>

                    <?php } ?>

                </div>
                

            </div>

        </div>  
            
    <?php }
endif;

// Save metabox value.
add_action( 'save_post', 'advance_blog_save_post_meta' );

if( ! function_exists( 'advance_blog_save_post_meta' ) ):

    function advance_blog_save_post_meta( $post_id ) {

        global $post, $advance_blog_post_sidebar_fields;

        if ( !isset( $_POST[ 'advance_blog_post_meta_nonce' ] ) || !wp_verify_nonce( sanitize_text_field( wp_unslash( $_POST['advance_blog_post_meta_nonce'] ) ), basename( __FILE__ ) ) ){

            return;

        }

        if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ){

            return;

        }
            
        if ( 'page' == $_POST['post_type'] ) {  

            if ( !current_user_can( 'edit_page', $post_id ) ){  

                return $post_id;

            }

        }elseif( !current_user_can( 'edit_post', $post_id ) ) {

            return $post_id;

        }


        foreach ( $advance_blog_post_sidebar_fields as $advance_blog_post_sidebar_field ) {  
            
            $old = sanitize_text_field( get_post_meta( $post_id, 'advance_blog_post_sidebar_option', true ) ); 
            $new = wp_unslash( $_POST['advance_blog_post_sidebar_option'] );

            if ( $new && $new != $old ){

                update_post_meta ( $post_id, 'advance_blog_post_sidebar_option', $new );

            }elseif( '' == $new && $old ) {

                delete_post_meta( $post_id,'advance_blog_post_sidebar_option', $old );

            }
            
        }

        $advance_blog_background_color_old = get_post_meta($post_id, 'advance_blog_background_color', true);
        $advance_blog_background_color_news = $_POST['advance_blog_background_color'];
        
        if ($advance_blog_background_color_news && $advance_blog_background_color_news != $advance_blog_background_color_old) {
            update_post_meta($post_id, 'advance_blog_background_color', $advance_blog_background_color_news);
        } elseif ('' == $advance_blog_background_color_news && $advance_blog_background_color_old) {
            delete_post_meta($post_id, 'advance_blog_background_color', $advance_blog_background_color_old);
        }

        $advance_blog_text_color_old = get_post_meta($post_id, 'advance_blog_text_color', true);
        $advance_blog_text_color_news = $_POST['advance_blog_text_color'];
        
        if ($advance_blog_text_color_news && $advance_blog_text_color_news != $advance_blog_text_color_old) {
            update_post_meta($post_id, 'advance_blog_text_color', $advance_blog_text_color_news);
        } elseif ('' == $advance_blog_text_color_news && $advance_blog_text_color_old) {
            delete_post_meta($post_id, 'advance_blog_text_color', $advance_blog_text_color_old);
        }
        

        $advance_blog_ed_feature_image_old = get_post_meta($post_id, 'advance-blog-meta-checkbox', true);
        $advance_blog_ed_feature_image_news = $_POST['advance-blog-meta-checkbox'];
        
        if ($advance_blog_ed_feature_image_news && $advance_blog_ed_feature_image_news != $advance_blog_ed_feature_image_old) {
            update_post_meta($post_id, 'advance-blog-meta-checkbox', $advance_blog_ed_feature_image_news);
        } elseif ('' == $advance_blog_ed_feature_image_news && $advance_blog_ed_feature_image_old) {
            delete_post_meta($post_id, 'advance-blog-meta-checkbox', $advance_blog_ed_feature_image_old);
        }

    }

endif;   